/* Generated by the protocol buffer compiler.  DO NOT EDIT! */
/* Generated from: apex/core.proto */

#ifndef PROTOBUF_C_apex_2fcore_2eproto__INCLUDED
#define PROTOBUF_C_apex_2fcore_2eproto__INCLUDED

#include <protobuf-c/protobuf-c.h>

PROTOBUF_C__BEGIN_DECLS

#if PROTOBUF_C_VERSION_NUMBER < 1003000
# error This file was generated by a newer version of protoc-c which is incompatible with your libprotobuf-c headers. Please update your headers.
#elif 1003001 < PROTOBUF_C_MIN_COMPILER_VERSION
# error This file was generated by an older version of protoc-c which is incompatible with your libprotobuf-c headers. Please regenerate this file with a newer version of protoc-c.
#endif


typedef struct _Apex__Empty Apex__Empty;
typedef struct _Apex__Property Apex__Property;
typedef struct _Apex__Object Apex__Object;
typedef struct _Apex__Configuration Apex__Configuration;
typedef struct _Apex__Job Apex__Job;
typedef struct _Apex__Settings Apex__Settings;
typedef struct _Apex__Settings__PropertiesEntry Apex__Settings__PropertiesEntry;
typedef struct _Apex__Channel Apex__Channel;
typedef struct _Apex__Status Apex__Status;
typedef struct _Apex__Status__DetailsEntry Apex__Status__DetailsEntry;
typedef struct _Apex__State Apex__State;
typedef struct _Apex__Event Apex__Event;
typedef struct _Apex__Service Apex__Service;
typedef struct _Apex__Module Apex__Module;
typedef struct _Apex__System Apex__System;
typedef struct _Apex__System__ServicesEntry Apex__System__ServicesEntry;
typedef struct _Apex__System__ModulesEntry Apex__System__ModulesEntry;
typedef struct _Apex__ConfigurationRequest Apex__ConfigurationRequest;
typedef struct _Apex__ConfigurationResponse Apex__ConfigurationResponse;
typedef struct _Apex__ConfigurationsResponse Apex__ConfigurationsResponse;
typedef struct _Apex__SettingsRequest Apex__SettingsRequest;
typedef struct _Apex__SettingsResponse Apex__SettingsResponse;
typedef struct _Apex__SettingsResponse__SettingsEntry Apex__SettingsResponse__SettingsEntry;
typedef struct _Apex__StatusRequest Apex__StatusRequest;
typedef struct _Apex__StatusResponse Apex__StatusResponse;
typedef struct _Apex__ChannelRequest Apex__ChannelRequest;
typedef struct _Apex__ChannelResponse Apex__ChannelResponse;
typedef struct _Apex__ChannelsResponse Apex__ChannelsResponse;
typedef struct _Apex__JobRequest Apex__JobRequest;
typedef struct _Apex__JobResponse Apex__JobResponse;
typedef struct _Apex__JobsResponse Apex__JobsResponse;
typedef struct _Apex__JobStatusResponse Apex__JobStatusResponse;
typedef struct _Apex__EventRequest Apex__EventRequest;
typedef struct _Apex__EventsResponse Apex__EventsResponse;
typedef struct _Apex__ModuleRequest Apex__ModuleRequest;
typedef struct _Apex__ModuleResponse Apex__ModuleResponse;
typedef struct _Apex__ModulesResponse Apex__ModulesResponse;
typedef struct _Apex__ModuleJobRequest Apex__ModuleJobRequest;
typedef struct _Apex__ModuleEventRequest Apex__ModuleEventRequest;


/* --- enums --- */

typedef enum _Apex__Configuration__Namespace {
  APEX__CONFIGURATION__NAMESPACE__ACQUIRE = 0,
  APEX__CONFIGURATION__NAMESPACE__ANALYZE = 1,
  APEX__CONFIGURATION__NAMESPACE__CONTROL = 2,
  APEX__CONFIGURATION__NAMESPACE__EXPERIMENT = 3,
  APEX__CONFIGURATION__NAMESPACE__MONITOR = 4,
  APEX__CONFIGURATION__NAMESPACE__PRESENT = 5,
  APEX__CONFIGURATION__NAMESPACE__RECORD = 6,
  APEX__CONFIGURATION__NAMESPACE__STATE = 7
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(APEX__CONFIGURATION__NAMESPACE)
} Apex__Configuration__Namespace;
typedef enum _Apex__Job__Status {
  APEX__JOB__STATUS__SUBMITTED = 0,
  APEX__JOB__STATUS__READY = 1,
  APEX__JOB__STATUS__STARTED = 2,
  APEX__JOB__STATUS__RUNNING = 3,
  APEX__JOB__STATUS__PAUSED = 4,
  APEX__JOB__STATUS__RESUMED = 5,
  APEX__JOB__STATUS__STOPPED = 6,
  APEX__JOB__STATUS__FAILED = 7
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(APEX__JOB__STATUS)
} Apex__Job__Status;
typedef enum _Apex__Channel__Type {
  APEX__CHANNEL__TYPE__SOURCE = 0,
  APEX__CHANNEL__TYPE__SINK = 1
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(APEX__CHANNEL__TYPE)
} Apex__Channel__Type;
typedef enum _Apex__Service__Type {
  APEX__SERVICE__TYPE__ACQUIRE = 0,
  APEX__SERVICE__TYPE__ANALYZE = 1,
  APEX__SERVICE__TYPE__CONTROL = 2,
  APEX__SERVICE__TYPE__EXPERIMENT = 3,
  APEX__SERVICE__TYPE__MONITOR = 4,
  APEX__SERVICE__TYPE__PRESENT = 5,
  APEX__SERVICE__TYPE__RECORD = 6,
  APEX__SERVICE__TYPE__STATE = 7
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(APEX__SERVICE__TYPE)
} Apex__Service__Type;
typedef enum _Apex__JobRequest__Type {
  APEX__JOB_REQUEST__TYPE__NEW = 0
    PROTOBUF_C__FORCE_ENUM_TO_BE_INT_SIZE(APEX__JOB_REQUEST__TYPE)
} Apex__JobRequest__Type;

/* --- messages --- */

/*
 * An empty message for when no input is needed in an RPC
 */
struct  _Apex__Empty
{
  ProtobufCMessage base;
};
#define APEX__EMPTY__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__empty__descriptor) \
     }


/*
 * Key/Value entry that could probably be replaced by a map
 */
struct  _Apex__Property
{
  ProtobufCMessage base;
  char *key;
  /*
   *google.protobuf.Any value = 2;
   */
  char *value;
};
#define APEX__PROPERTY__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__property__descriptor) \
    , (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string }


/*
 * Nestable node in a tree
 */
struct  _Apex__Object
{
  ProtobufCMessage base;
  char *id;
  char *name;
  char *type;
  size_t n_properties;
  Apex__Property **properties;
  size_t n_objects;
  Apex__Object **objects;
};
#define APEX__OBJECT__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__object__descriptor) \
    , (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string, 0,NULL, 0,NULL }


struct  _Apex__Configuration
{
  ProtobufCMessage base;
  char *id;
  Apex__Configuration__Namespace namespace_;
  size_t n_properties;
  Apex__Property **properties;
  size_t n_objects;
  Apex__Object **objects;
};
#define APEX__CONFIGURATION__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__configuration__descriptor) \
    , (char *)protobuf_c_empty_string, APEX__CONFIGURATION__NAMESPACE__ACQUIRE, 0,NULL, 0,NULL }


struct  _Apex__Job
{
  ProtobufCMessage base;
  char *id;
  Apex__Job__Status status;
};
#define APEX__JOB__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__job__descriptor) \
    , (char *)protobuf_c_empty_string, APEX__JOB__STATUS__SUBMITTED }


struct  _Apex__Settings__PropertiesEntry
{
  ProtobufCMessage base;
  char *key;
  char *value;
};
#define APEX__SETTINGS__PROPERTIES_ENTRY__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__settings__properties_entry__descriptor) \
    , (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string }


struct  _Apex__Settings
{
  ProtobufCMessage base;
  /*
   * TODO: find out how to make V generic
   */
  size_t n_properties;
  Apex__Settings__PropertiesEntry **properties;
};
#define APEX__SETTINGS__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__settings__descriptor) \
    , 0,NULL }


struct  _Apex__Channel
{
  ProtobufCMessage base;
  Apex__Channel__Type type;
  char *endpoint;
  char *envelope;
};
#define APEX__CHANNEL__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__channel__descriptor) \
    , APEX__CHANNEL__TYPE__SOURCE, (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string }


struct  _Apex__Status__DetailsEntry
{
  ProtobufCMessage base;
  char *key;
  char *value;
};
#define APEX__STATUS__DETAILS_ENTRY__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__status__details_entry__descriptor) \
    , (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string }


/*
 * Service specific status message
 */
struct  _Apex__Status
{
  ProtobufCMessage base;
  /*
   * `true` when service will start on boot
   */
  protobuf_c_boolean enabled;
  /*
   * `true` when configuration has been read in, or connected to owner
   */
  protobuf_c_boolean loaded;
  /*
   * `true` when service is running and operational
   */
  protobuf_c_boolean active;
  /*
   * additional optional details
   */
  size_t n_details;
  Apex__Status__DetailsEntry **details;
};
#define APEX__STATUS__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__status__descriptor) \
    , 0, 0, 0, 0,NULL }


struct  _Apex__State
{
  ProtobufCMessage base;
  int32_t id;
  char *name;
  char *description;
};
#define APEX__STATE__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__state__descriptor) \
    , 0, (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string }


struct  _Apex__Event
{
  ProtobufCMessage base;
  int32_t id;
  char *name;
  char *description;
};
#define APEX__EVENT__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__event__descriptor) \
    , 0, (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string }


/*
 * Service type used in message responses
 */
struct  _Apex__Service
{
  ProtobufCMessage base;
  char *name;
  char *description;
  char *configuration_id;
  Apex__Status *status;
  Apex__State *state;
  Apex__Service__Type type;
};
#define APEX__SERVICE__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__service__descriptor) \
    , (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string, NULL, NULL, APEX__SERVICE__TYPE__ACQUIRE }


struct  _Apex__Module
{
  ProtobufCMessage base;
  char *id;
  char *name;
  char *service_name;
  char *configuration_id;
  Apex__Status *status;
  Apex__State *state;
  size_t n_types;
  Apex__Service__Type *types;
};
#define APEX__MODULE__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__module__descriptor) \
    , (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string, NULL, NULL, 0,NULL }


struct  _Apex__System__ServicesEntry
{
  ProtobufCMessage base;
  char *key;
  Apex__Service *value;
};
#define APEX__SYSTEM__SERVICES_ENTRY__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__system__services_entry__descriptor) \
    , (char *)protobuf_c_empty_string, NULL }


struct  _Apex__System__ModulesEntry
{
  ProtobufCMessage base;
  char *key;
  Apex__Module *value;
};
#define APEX__SYSTEM__MODULES_ENTRY__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__system__modules_entry__descriptor) \
    , (char *)protobuf_c_empty_string, NULL }


/*
 * XXX: Change to plant?
 */
struct  _Apex__System
{
  ProtobufCMessage base;
  Apex__Service *master;
  Apex__Service *broker;
  size_t n_services;
  Apex__System__ServicesEntry **services;
  size_t n_modules;
  Apex__System__ModulesEntry **modules;
};
#define APEX__SYSTEM__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__system__descriptor) \
    , NULL, NULL, 0,NULL, 0,NULL }


/*
 * Used to request a configuration by ID
 */
struct  _Apex__ConfigurationRequest
{
  ProtobufCMessage base;
  char *id;
  Apex__Configuration__Namespace namespace_;
};
#define APEX__CONFIGURATION_REQUEST__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__configuration_request__descriptor) \
    , (char *)protobuf_c_empty_string, APEX__CONFIGURATION__NAMESPACE__ACQUIRE }


/*
 * Contains the configuration data requested
 */
struct  _Apex__ConfigurationResponse
{
  ProtobufCMessage base;
  Apex__Configuration *configuration;
};
#define APEX__CONFIGURATION_RESPONSE__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__configuration_response__descriptor) \
    , NULL }


struct  _Apex__ConfigurationsResponse
{
  ProtobufCMessage base;
  size_t n_configurations;
  Apex__Configuration **configurations;
};
#define APEX__CONFIGURATIONS_RESPONSE__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__configurations_response__descriptor) \
    , 0,NULL }


struct  _Apex__SettingsRequest
{
  ProtobufCMessage base;
};
#define APEX__SETTINGS_REQUEST__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__settings_request__descriptor) \
     }


struct  _Apex__SettingsResponse__SettingsEntry
{
  ProtobufCMessage base;
  char *key;
  char *value;
};
#define APEX__SETTINGS_RESPONSE__SETTINGS_ENTRY__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__settings_response__settings_entry__descriptor) \
    , (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string }


struct  _Apex__SettingsResponse
{
  ProtobufCMessage base;
  char *id;
  /*
   * TODO: use Any or Oneof
   */
  size_t n_settings;
  Apex__SettingsResponse__SettingsEntry **settings;
};
#define APEX__SETTINGS_RESPONSE__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__settings_response__descriptor) \
    , (char *)protobuf_c_empty_string, 0,NULL }


struct  _Apex__StatusRequest
{
  ProtobufCMessage base;
};
#define APEX__STATUS_REQUEST__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__status_request__descriptor) \
     }


struct  _Apex__StatusResponse
{
  ProtobufCMessage base;
  Apex__Status *status;
};
#define APEX__STATUS_RESPONSE__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__status_response__descriptor) \
    , NULL }


struct  _Apex__ChannelRequest
{
  ProtobufCMessage base;
  char *id;
};
#define APEX__CHANNEL_REQUEST__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__channel_request__descriptor) \
    , (char *)protobuf_c_empty_string }


struct  _Apex__ChannelResponse
{
  ProtobufCMessage base;
  Apex__Channel *channel;
};
#define APEX__CHANNEL_RESPONSE__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__channel_response__descriptor) \
    , NULL }


struct  _Apex__ChannelsResponse
{
  ProtobufCMessage base;
  size_t n_channels;
  Apex__Channel **channels;
};
#define APEX__CHANNELS_RESPONSE__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__channels_response__descriptor) \
    , 0,NULL }


struct  _Apex__JobRequest
{
  ProtobufCMessage base;
  char *id;
  Apex__JobRequest__Type type;
};
#define APEX__JOB_REQUEST__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__job_request__descriptor) \
    , (char *)protobuf_c_empty_string, APEX__JOB_REQUEST__TYPE__NEW }


struct  _Apex__JobResponse
{
  ProtobufCMessage base;
  Apex__Job *job;
};
#define APEX__JOB_RESPONSE__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__job_response__descriptor) \
    , NULL }


struct  _Apex__JobsResponse
{
  ProtobufCMessage base;
  size_t n_jobs;
  Apex__Job **jobs;
};
#define APEX__JOBS_RESPONSE__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__jobs_response__descriptor) \
    , 0,NULL }


struct  _Apex__JobStatusResponse
{
  ProtobufCMessage base;
  Apex__Job *job;
};
#define APEX__JOB_STATUS_RESPONSE__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__job_status_response__descriptor) \
    , NULL }


struct  _Apex__EventRequest
{
  ProtobufCMessage base;
  Apex__Event *event;
};
#define APEX__EVENT_REQUEST__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__event_request__descriptor) \
    , NULL }


struct  _Apex__EventsResponse
{
  ProtobufCMessage base;
  size_t n_events;
  Apex__Event **events;
};
#define APEX__EVENTS_RESPONSE__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__events_response__descriptor) \
    , 0,NULL }


struct  _Apex__ModuleRequest
{
  ProtobufCMessage base;
  char *id;
};
#define APEX__MODULE_REQUEST__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__module_request__descriptor) \
    , (char *)protobuf_c_empty_string }


struct  _Apex__ModuleResponse
{
  ProtobufCMessage base;
  Apex__Module *module;
};
#define APEX__MODULE_RESPONSE__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__module_response__descriptor) \
    , NULL }


struct  _Apex__ModulesResponse
{
  ProtobufCMessage base;
  size_t n_modules;
  Apex__Module **modules;
};
#define APEX__MODULES_RESPONSE__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__modules_response__descriptor) \
    , 0,NULL }


struct  _Apex__ModuleJobRequest
{
  ProtobufCMessage base;
  /*
   * ID of the module to call
   */
  char *id;
  /*
   * Job ID to modify/query
   */
  char *job_id;
};
#define APEX__MODULE_JOB_REQUEST__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__module_job_request__descriptor) \
    , (char *)protobuf_c_empty_string, (char *)protobuf_c_empty_string }


struct  _Apex__ModuleEventRequest
{
  ProtobufCMessage base;
  /*
   * ID of the module to call
   */
  char *id;
  /*
   * Event ID to modify/query
   */
  int32_t event_id;
};
#define APEX__MODULE_EVENT_REQUEST__INIT \
 { PROTOBUF_C_MESSAGE_INIT (&apex__module_event_request__descriptor) \
    , (char *)protobuf_c_empty_string, 0 }


/* Apex__Empty methods */
void   apex__empty__init
                     (Apex__Empty         *message);
size_t apex__empty__get_packed_size
                     (const Apex__Empty   *message);
size_t apex__empty__pack
                     (const Apex__Empty   *message,
                      uint8_t             *out);
size_t apex__empty__pack_to_buffer
                     (const Apex__Empty   *message,
                      ProtobufCBuffer     *buffer);
Apex__Empty *
       apex__empty__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__empty__free_unpacked
                     (Apex__Empty *message,
                      ProtobufCAllocator *allocator);
/* Apex__Property methods */
void   apex__property__init
                     (Apex__Property         *message);
size_t apex__property__get_packed_size
                     (const Apex__Property   *message);
size_t apex__property__pack
                     (const Apex__Property   *message,
                      uint8_t             *out);
size_t apex__property__pack_to_buffer
                     (const Apex__Property   *message,
                      ProtobufCBuffer     *buffer);
Apex__Property *
       apex__property__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__property__free_unpacked
                     (Apex__Property *message,
                      ProtobufCAllocator *allocator);
/* Apex__Object methods */
void   apex__object__init
                     (Apex__Object         *message);
size_t apex__object__get_packed_size
                     (const Apex__Object   *message);
size_t apex__object__pack
                     (const Apex__Object   *message,
                      uint8_t             *out);
size_t apex__object__pack_to_buffer
                     (const Apex__Object   *message,
                      ProtobufCBuffer     *buffer);
Apex__Object *
       apex__object__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__object__free_unpacked
                     (Apex__Object *message,
                      ProtobufCAllocator *allocator);
/* Apex__Configuration methods */
void   apex__configuration__init
                     (Apex__Configuration         *message);
size_t apex__configuration__get_packed_size
                     (const Apex__Configuration   *message);
size_t apex__configuration__pack
                     (const Apex__Configuration   *message,
                      uint8_t             *out);
size_t apex__configuration__pack_to_buffer
                     (const Apex__Configuration   *message,
                      ProtobufCBuffer     *buffer);
Apex__Configuration *
       apex__configuration__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__configuration__free_unpacked
                     (Apex__Configuration *message,
                      ProtobufCAllocator *allocator);
/* Apex__Job methods */
void   apex__job__init
                     (Apex__Job         *message);
size_t apex__job__get_packed_size
                     (const Apex__Job   *message);
size_t apex__job__pack
                     (const Apex__Job   *message,
                      uint8_t             *out);
size_t apex__job__pack_to_buffer
                     (const Apex__Job   *message,
                      ProtobufCBuffer     *buffer);
Apex__Job *
       apex__job__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__job__free_unpacked
                     (Apex__Job *message,
                      ProtobufCAllocator *allocator);
/* Apex__Settings__PropertiesEntry methods */
void   apex__settings__properties_entry__init
                     (Apex__Settings__PropertiesEntry         *message);
/* Apex__Settings methods */
void   apex__settings__init
                     (Apex__Settings         *message);
size_t apex__settings__get_packed_size
                     (const Apex__Settings   *message);
size_t apex__settings__pack
                     (const Apex__Settings   *message,
                      uint8_t             *out);
size_t apex__settings__pack_to_buffer
                     (const Apex__Settings   *message,
                      ProtobufCBuffer     *buffer);
Apex__Settings *
       apex__settings__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__settings__free_unpacked
                     (Apex__Settings *message,
                      ProtobufCAllocator *allocator);
/* Apex__Channel methods */
void   apex__channel__init
                     (Apex__Channel         *message);
size_t apex__channel__get_packed_size
                     (const Apex__Channel   *message);
size_t apex__channel__pack
                     (const Apex__Channel   *message,
                      uint8_t             *out);
size_t apex__channel__pack_to_buffer
                     (const Apex__Channel   *message,
                      ProtobufCBuffer     *buffer);
Apex__Channel *
       apex__channel__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__channel__free_unpacked
                     (Apex__Channel *message,
                      ProtobufCAllocator *allocator);
/* Apex__Status__DetailsEntry methods */
void   apex__status__details_entry__init
                     (Apex__Status__DetailsEntry         *message);
/* Apex__Status methods */
void   apex__status__init
                     (Apex__Status         *message);
size_t apex__status__get_packed_size
                     (const Apex__Status   *message);
size_t apex__status__pack
                     (const Apex__Status   *message,
                      uint8_t             *out);
size_t apex__status__pack_to_buffer
                     (const Apex__Status   *message,
                      ProtobufCBuffer     *buffer);
Apex__Status *
       apex__status__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__status__free_unpacked
                     (Apex__Status *message,
                      ProtobufCAllocator *allocator);
/* Apex__State methods */
void   apex__state__init
                     (Apex__State         *message);
size_t apex__state__get_packed_size
                     (const Apex__State   *message);
size_t apex__state__pack
                     (const Apex__State   *message,
                      uint8_t             *out);
size_t apex__state__pack_to_buffer
                     (const Apex__State   *message,
                      ProtobufCBuffer     *buffer);
Apex__State *
       apex__state__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__state__free_unpacked
                     (Apex__State *message,
                      ProtobufCAllocator *allocator);
/* Apex__Event methods */
void   apex__event__init
                     (Apex__Event         *message);
size_t apex__event__get_packed_size
                     (const Apex__Event   *message);
size_t apex__event__pack
                     (const Apex__Event   *message,
                      uint8_t             *out);
size_t apex__event__pack_to_buffer
                     (const Apex__Event   *message,
                      ProtobufCBuffer     *buffer);
Apex__Event *
       apex__event__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__event__free_unpacked
                     (Apex__Event *message,
                      ProtobufCAllocator *allocator);
/* Apex__Service methods */
void   apex__service__init
                     (Apex__Service         *message);
size_t apex__service__get_packed_size
                     (const Apex__Service   *message);
size_t apex__service__pack
                     (const Apex__Service   *message,
                      uint8_t             *out);
size_t apex__service__pack_to_buffer
                     (const Apex__Service   *message,
                      ProtobufCBuffer     *buffer);
Apex__Service *
       apex__service__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__service__free_unpacked
                     (Apex__Service *message,
                      ProtobufCAllocator *allocator);
/* Apex__Module methods */
void   apex__module__init
                     (Apex__Module         *message);
size_t apex__module__get_packed_size
                     (const Apex__Module   *message);
size_t apex__module__pack
                     (const Apex__Module   *message,
                      uint8_t             *out);
size_t apex__module__pack_to_buffer
                     (const Apex__Module   *message,
                      ProtobufCBuffer     *buffer);
Apex__Module *
       apex__module__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__module__free_unpacked
                     (Apex__Module *message,
                      ProtobufCAllocator *allocator);
/* Apex__System__ServicesEntry methods */
void   apex__system__services_entry__init
                     (Apex__System__ServicesEntry         *message);
/* Apex__System__ModulesEntry methods */
void   apex__system__modules_entry__init
                     (Apex__System__ModulesEntry         *message);
/* Apex__System methods */
void   apex__system__init
                     (Apex__System         *message);
size_t apex__system__get_packed_size
                     (const Apex__System   *message);
size_t apex__system__pack
                     (const Apex__System   *message,
                      uint8_t             *out);
size_t apex__system__pack_to_buffer
                     (const Apex__System   *message,
                      ProtobufCBuffer     *buffer);
Apex__System *
       apex__system__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__system__free_unpacked
                     (Apex__System *message,
                      ProtobufCAllocator *allocator);
/* Apex__ConfigurationRequest methods */
void   apex__configuration_request__init
                     (Apex__ConfigurationRequest         *message);
size_t apex__configuration_request__get_packed_size
                     (const Apex__ConfigurationRequest   *message);
size_t apex__configuration_request__pack
                     (const Apex__ConfigurationRequest   *message,
                      uint8_t             *out);
size_t apex__configuration_request__pack_to_buffer
                     (const Apex__ConfigurationRequest   *message,
                      ProtobufCBuffer     *buffer);
Apex__ConfigurationRequest *
       apex__configuration_request__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__configuration_request__free_unpacked
                     (Apex__ConfigurationRequest *message,
                      ProtobufCAllocator *allocator);
/* Apex__ConfigurationResponse methods */
void   apex__configuration_response__init
                     (Apex__ConfigurationResponse         *message);
size_t apex__configuration_response__get_packed_size
                     (const Apex__ConfigurationResponse   *message);
size_t apex__configuration_response__pack
                     (const Apex__ConfigurationResponse   *message,
                      uint8_t             *out);
size_t apex__configuration_response__pack_to_buffer
                     (const Apex__ConfigurationResponse   *message,
                      ProtobufCBuffer     *buffer);
Apex__ConfigurationResponse *
       apex__configuration_response__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__configuration_response__free_unpacked
                     (Apex__ConfigurationResponse *message,
                      ProtobufCAllocator *allocator);
/* Apex__ConfigurationsResponse methods */
void   apex__configurations_response__init
                     (Apex__ConfigurationsResponse         *message);
size_t apex__configurations_response__get_packed_size
                     (const Apex__ConfigurationsResponse   *message);
size_t apex__configurations_response__pack
                     (const Apex__ConfigurationsResponse   *message,
                      uint8_t             *out);
size_t apex__configurations_response__pack_to_buffer
                     (const Apex__ConfigurationsResponse   *message,
                      ProtobufCBuffer     *buffer);
Apex__ConfigurationsResponse *
       apex__configurations_response__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__configurations_response__free_unpacked
                     (Apex__ConfigurationsResponse *message,
                      ProtobufCAllocator *allocator);
/* Apex__SettingsRequest methods */
void   apex__settings_request__init
                     (Apex__SettingsRequest         *message);
size_t apex__settings_request__get_packed_size
                     (const Apex__SettingsRequest   *message);
size_t apex__settings_request__pack
                     (const Apex__SettingsRequest   *message,
                      uint8_t             *out);
size_t apex__settings_request__pack_to_buffer
                     (const Apex__SettingsRequest   *message,
                      ProtobufCBuffer     *buffer);
Apex__SettingsRequest *
       apex__settings_request__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__settings_request__free_unpacked
                     (Apex__SettingsRequest *message,
                      ProtobufCAllocator *allocator);
/* Apex__SettingsResponse__SettingsEntry methods */
void   apex__settings_response__settings_entry__init
                     (Apex__SettingsResponse__SettingsEntry         *message);
/* Apex__SettingsResponse methods */
void   apex__settings_response__init
                     (Apex__SettingsResponse         *message);
size_t apex__settings_response__get_packed_size
                     (const Apex__SettingsResponse   *message);
size_t apex__settings_response__pack
                     (const Apex__SettingsResponse   *message,
                      uint8_t             *out);
size_t apex__settings_response__pack_to_buffer
                     (const Apex__SettingsResponse   *message,
                      ProtobufCBuffer     *buffer);
Apex__SettingsResponse *
       apex__settings_response__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__settings_response__free_unpacked
                     (Apex__SettingsResponse *message,
                      ProtobufCAllocator *allocator);
/* Apex__StatusRequest methods */
void   apex__status_request__init
                     (Apex__StatusRequest         *message);
size_t apex__status_request__get_packed_size
                     (const Apex__StatusRequest   *message);
size_t apex__status_request__pack
                     (const Apex__StatusRequest   *message,
                      uint8_t             *out);
size_t apex__status_request__pack_to_buffer
                     (const Apex__StatusRequest   *message,
                      ProtobufCBuffer     *buffer);
Apex__StatusRequest *
       apex__status_request__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__status_request__free_unpacked
                     (Apex__StatusRequest *message,
                      ProtobufCAllocator *allocator);
/* Apex__StatusResponse methods */
void   apex__status_response__init
                     (Apex__StatusResponse         *message);
size_t apex__status_response__get_packed_size
                     (const Apex__StatusResponse   *message);
size_t apex__status_response__pack
                     (const Apex__StatusResponse   *message,
                      uint8_t             *out);
size_t apex__status_response__pack_to_buffer
                     (const Apex__StatusResponse   *message,
                      ProtobufCBuffer     *buffer);
Apex__StatusResponse *
       apex__status_response__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__status_response__free_unpacked
                     (Apex__StatusResponse *message,
                      ProtobufCAllocator *allocator);
/* Apex__ChannelRequest methods */
void   apex__channel_request__init
                     (Apex__ChannelRequest         *message);
size_t apex__channel_request__get_packed_size
                     (const Apex__ChannelRequest   *message);
size_t apex__channel_request__pack
                     (const Apex__ChannelRequest   *message,
                      uint8_t             *out);
size_t apex__channel_request__pack_to_buffer
                     (const Apex__ChannelRequest   *message,
                      ProtobufCBuffer     *buffer);
Apex__ChannelRequest *
       apex__channel_request__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__channel_request__free_unpacked
                     (Apex__ChannelRequest *message,
                      ProtobufCAllocator *allocator);
/* Apex__ChannelResponse methods */
void   apex__channel_response__init
                     (Apex__ChannelResponse         *message);
size_t apex__channel_response__get_packed_size
                     (const Apex__ChannelResponse   *message);
size_t apex__channel_response__pack
                     (const Apex__ChannelResponse   *message,
                      uint8_t             *out);
size_t apex__channel_response__pack_to_buffer
                     (const Apex__ChannelResponse   *message,
                      ProtobufCBuffer     *buffer);
Apex__ChannelResponse *
       apex__channel_response__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__channel_response__free_unpacked
                     (Apex__ChannelResponse *message,
                      ProtobufCAllocator *allocator);
/* Apex__ChannelsResponse methods */
void   apex__channels_response__init
                     (Apex__ChannelsResponse         *message);
size_t apex__channels_response__get_packed_size
                     (const Apex__ChannelsResponse   *message);
size_t apex__channels_response__pack
                     (const Apex__ChannelsResponse   *message,
                      uint8_t             *out);
size_t apex__channels_response__pack_to_buffer
                     (const Apex__ChannelsResponse   *message,
                      ProtobufCBuffer     *buffer);
Apex__ChannelsResponse *
       apex__channels_response__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__channels_response__free_unpacked
                     (Apex__ChannelsResponse *message,
                      ProtobufCAllocator *allocator);
/* Apex__JobRequest methods */
void   apex__job_request__init
                     (Apex__JobRequest         *message);
size_t apex__job_request__get_packed_size
                     (const Apex__JobRequest   *message);
size_t apex__job_request__pack
                     (const Apex__JobRequest   *message,
                      uint8_t             *out);
size_t apex__job_request__pack_to_buffer
                     (const Apex__JobRequest   *message,
                      ProtobufCBuffer     *buffer);
Apex__JobRequest *
       apex__job_request__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__job_request__free_unpacked
                     (Apex__JobRequest *message,
                      ProtobufCAllocator *allocator);
/* Apex__JobResponse methods */
void   apex__job_response__init
                     (Apex__JobResponse         *message);
size_t apex__job_response__get_packed_size
                     (const Apex__JobResponse   *message);
size_t apex__job_response__pack
                     (const Apex__JobResponse   *message,
                      uint8_t             *out);
size_t apex__job_response__pack_to_buffer
                     (const Apex__JobResponse   *message,
                      ProtobufCBuffer     *buffer);
Apex__JobResponse *
       apex__job_response__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__job_response__free_unpacked
                     (Apex__JobResponse *message,
                      ProtobufCAllocator *allocator);
/* Apex__JobsResponse methods */
void   apex__jobs_response__init
                     (Apex__JobsResponse         *message);
size_t apex__jobs_response__get_packed_size
                     (const Apex__JobsResponse   *message);
size_t apex__jobs_response__pack
                     (const Apex__JobsResponse   *message,
                      uint8_t             *out);
size_t apex__jobs_response__pack_to_buffer
                     (const Apex__JobsResponse   *message,
                      ProtobufCBuffer     *buffer);
Apex__JobsResponse *
       apex__jobs_response__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__jobs_response__free_unpacked
                     (Apex__JobsResponse *message,
                      ProtobufCAllocator *allocator);
/* Apex__JobStatusResponse methods */
void   apex__job_status_response__init
                     (Apex__JobStatusResponse         *message);
size_t apex__job_status_response__get_packed_size
                     (const Apex__JobStatusResponse   *message);
size_t apex__job_status_response__pack
                     (const Apex__JobStatusResponse   *message,
                      uint8_t             *out);
size_t apex__job_status_response__pack_to_buffer
                     (const Apex__JobStatusResponse   *message,
                      ProtobufCBuffer     *buffer);
Apex__JobStatusResponse *
       apex__job_status_response__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__job_status_response__free_unpacked
                     (Apex__JobStatusResponse *message,
                      ProtobufCAllocator *allocator);
/* Apex__EventRequest methods */
void   apex__event_request__init
                     (Apex__EventRequest         *message);
size_t apex__event_request__get_packed_size
                     (const Apex__EventRequest   *message);
size_t apex__event_request__pack
                     (const Apex__EventRequest   *message,
                      uint8_t             *out);
size_t apex__event_request__pack_to_buffer
                     (const Apex__EventRequest   *message,
                      ProtobufCBuffer     *buffer);
Apex__EventRequest *
       apex__event_request__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__event_request__free_unpacked
                     (Apex__EventRequest *message,
                      ProtobufCAllocator *allocator);
/* Apex__EventsResponse methods */
void   apex__events_response__init
                     (Apex__EventsResponse         *message);
size_t apex__events_response__get_packed_size
                     (const Apex__EventsResponse   *message);
size_t apex__events_response__pack
                     (const Apex__EventsResponse   *message,
                      uint8_t             *out);
size_t apex__events_response__pack_to_buffer
                     (const Apex__EventsResponse   *message,
                      ProtobufCBuffer     *buffer);
Apex__EventsResponse *
       apex__events_response__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__events_response__free_unpacked
                     (Apex__EventsResponse *message,
                      ProtobufCAllocator *allocator);
/* Apex__ModuleRequest methods */
void   apex__module_request__init
                     (Apex__ModuleRequest         *message);
size_t apex__module_request__get_packed_size
                     (const Apex__ModuleRequest   *message);
size_t apex__module_request__pack
                     (const Apex__ModuleRequest   *message,
                      uint8_t             *out);
size_t apex__module_request__pack_to_buffer
                     (const Apex__ModuleRequest   *message,
                      ProtobufCBuffer     *buffer);
Apex__ModuleRequest *
       apex__module_request__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__module_request__free_unpacked
                     (Apex__ModuleRequest *message,
                      ProtobufCAllocator *allocator);
/* Apex__ModuleResponse methods */
void   apex__module_response__init
                     (Apex__ModuleResponse         *message);
size_t apex__module_response__get_packed_size
                     (const Apex__ModuleResponse   *message);
size_t apex__module_response__pack
                     (const Apex__ModuleResponse   *message,
                      uint8_t             *out);
size_t apex__module_response__pack_to_buffer
                     (const Apex__ModuleResponse   *message,
                      ProtobufCBuffer     *buffer);
Apex__ModuleResponse *
       apex__module_response__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__module_response__free_unpacked
                     (Apex__ModuleResponse *message,
                      ProtobufCAllocator *allocator);
/* Apex__ModulesResponse methods */
void   apex__modules_response__init
                     (Apex__ModulesResponse         *message);
size_t apex__modules_response__get_packed_size
                     (const Apex__ModulesResponse   *message);
size_t apex__modules_response__pack
                     (const Apex__ModulesResponse   *message,
                      uint8_t             *out);
size_t apex__modules_response__pack_to_buffer
                     (const Apex__ModulesResponse   *message,
                      ProtobufCBuffer     *buffer);
Apex__ModulesResponse *
       apex__modules_response__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__modules_response__free_unpacked
                     (Apex__ModulesResponse *message,
                      ProtobufCAllocator *allocator);
/* Apex__ModuleJobRequest methods */
void   apex__module_job_request__init
                     (Apex__ModuleJobRequest         *message);
size_t apex__module_job_request__get_packed_size
                     (const Apex__ModuleJobRequest   *message);
size_t apex__module_job_request__pack
                     (const Apex__ModuleJobRequest   *message,
                      uint8_t             *out);
size_t apex__module_job_request__pack_to_buffer
                     (const Apex__ModuleJobRequest   *message,
                      ProtobufCBuffer     *buffer);
Apex__ModuleJobRequest *
       apex__module_job_request__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__module_job_request__free_unpacked
                     (Apex__ModuleJobRequest *message,
                      ProtobufCAllocator *allocator);
/* Apex__ModuleEventRequest methods */
void   apex__module_event_request__init
                     (Apex__ModuleEventRequest         *message);
size_t apex__module_event_request__get_packed_size
                     (const Apex__ModuleEventRequest   *message);
size_t apex__module_event_request__pack
                     (const Apex__ModuleEventRequest   *message,
                      uint8_t             *out);
size_t apex__module_event_request__pack_to_buffer
                     (const Apex__ModuleEventRequest   *message,
                      ProtobufCBuffer     *buffer);
Apex__ModuleEventRequest *
       apex__module_event_request__unpack
                     (ProtobufCAllocator  *allocator,
                      size_t               len,
                      const uint8_t       *data);
void   apex__module_event_request__free_unpacked
                     (Apex__ModuleEventRequest *message,
                      ProtobufCAllocator *allocator);
/* --- per-message closures --- */

typedef void (*Apex__Empty_Closure)
                 (const Apex__Empty *message,
                  void *closure_data);
typedef void (*Apex__Property_Closure)
                 (const Apex__Property *message,
                  void *closure_data);
typedef void (*Apex__Object_Closure)
                 (const Apex__Object *message,
                  void *closure_data);
typedef void (*Apex__Configuration_Closure)
                 (const Apex__Configuration *message,
                  void *closure_data);
typedef void (*Apex__Job_Closure)
                 (const Apex__Job *message,
                  void *closure_data);
typedef void (*Apex__Settings__PropertiesEntry_Closure)
                 (const Apex__Settings__PropertiesEntry *message,
                  void *closure_data);
typedef void (*Apex__Settings_Closure)
                 (const Apex__Settings *message,
                  void *closure_data);
typedef void (*Apex__Channel_Closure)
                 (const Apex__Channel *message,
                  void *closure_data);
typedef void (*Apex__Status__DetailsEntry_Closure)
                 (const Apex__Status__DetailsEntry *message,
                  void *closure_data);
typedef void (*Apex__Status_Closure)
                 (const Apex__Status *message,
                  void *closure_data);
typedef void (*Apex__State_Closure)
                 (const Apex__State *message,
                  void *closure_data);
typedef void (*Apex__Event_Closure)
                 (const Apex__Event *message,
                  void *closure_data);
typedef void (*Apex__Service_Closure)
                 (const Apex__Service *message,
                  void *closure_data);
typedef void (*Apex__Module_Closure)
                 (const Apex__Module *message,
                  void *closure_data);
typedef void (*Apex__System__ServicesEntry_Closure)
                 (const Apex__System__ServicesEntry *message,
                  void *closure_data);
typedef void (*Apex__System__ModulesEntry_Closure)
                 (const Apex__System__ModulesEntry *message,
                  void *closure_data);
typedef void (*Apex__System_Closure)
                 (const Apex__System *message,
                  void *closure_data);
typedef void (*Apex__ConfigurationRequest_Closure)
                 (const Apex__ConfigurationRequest *message,
                  void *closure_data);
typedef void (*Apex__ConfigurationResponse_Closure)
                 (const Apex__ConfigurationResponse *message,
                  void *closure_data);
typedef void (*Apex__ConfigurationsResponse_Closure)
                 (const Apex__ConfigurationsResponse *message,
                  void *closure_data);
typedef void (*Apex__SettingsRequest_Closure)
                 (const Apex__SettingsRequest *message,
                  void *closure_data);
typedef void (*Apex__SettingsResponse__SettingsEntry_Closure)
                 (const Apex__SettingsResponse__SettingsEntry *message,
                  void *closure_data);
typedef void (*Apex__SettingsResponse_Closure)
                 (const Apex__SettingsResponse *message,
                  void *closure_data);
typedef void (*Apex__StatusRequest_Closure)
                 (const Apex__StatusRequest *message,
                  void *closure_data);
typedef void (*Apex__StatusResponse_Closure)
                 (const Apex__StatusResponse *message,
                  void *closure_data);
typedef void (*Apex__ChannelRequest_Closure)
                 (const Apex__ChannelRequest *message,
                  void *closure_data);
typedef void (*Apex__ChannelResponse_Closure)
                 (const Apex__ChannelResponse *message,
                  void *closure_data);
typedef void (*Apex__ChannelsResponse_Closure)
                 (const Apex__ChannelsResponse *message,
                  void *closure_data);
typedef void (*Apex__JobRequest_Closure)
                 (const Apex__JobRequest *message,
                  void *closure_data);
typedef void (*Apex__JobResponse_Closure)
                 (const Apex__JobResponse *message,
                  void *closure_data);
typedef void (*Apex__JobsResponse_Closure)
                 (const Apex__JobsResponse *message,
                  void *closure_data);
typedef void (*Apex__JobStatusResponse_Closure)
                 (const Apex__JobStatusResponse *message,
                  void *closure_data);
typedef void (*Apex__EventRequest_Closure)
                 (const Apex__EventRequest *message,
                  void *closure_data);
typedef void (*Apex__EventsResponse_Closure)
                 (const Apex__EventsResponse *message,
                  void *closure_data);
typedef void (*Apex__ModuleRequest_Closure)
                 (const Apex__ModuleRequest *message,
                  void *closure_data);
typedef void (*Apex__ModuleResponse_Closure)
                 (const Apex__ModuleResponse *message,
                  void *closure_data);
typedef void (*Apex__ModulesResponse_Closure)
                 (const Apex__ModulesResponse *message,
                  void *closure_data);
typedef void (*Apex__ModuleJobRequest_Closure)
                 (const Apex__ModuleJobRequest *message,
                  void *closure_data);
typedef void (*Apex__ModuleEventRequest_Closure)
                 (const Apex__ModuleEventRequest *message,
                  void *closure_data);

/* --- services --- */

typedef struct _Apex__Endpoint_Service Apex__Endpoint_Service;
struct _Apex__Endpoint_Service
{
  ProtobufCService base;
  void (*get_unit_configuration)(Apex__Endpoint_Service *service,
                                 const Apex__Empty *input,
                                 Apex__ConfigurationResponse_Closure closure,
                                 void *closure_data);
  void (*get_configuration)(Apex__Endpoint_Service *service,
                            const Apex__ConfigurationRequest *input,
                            Apex__ConfigurationResponse_Closure closure,
                            void *closure_data);
  void (*get_status)(Apex__Endpoint_Service *service,
                     const Apex__StatusRequest *input,
                     Apex__StatusResponse_Closure closure,
                     void *closure_data);
  void (*get_settings)(Apex__Endpoint_Service *service,
                       const Apex__SettingsRequest *input,
                       Apex__SettingsResponse_Closure closure,
                       void *closure_data);
  void (*get_channel)(Apex__Endpoint_Service *service,
                      const Apex__ChannelRequest *input,
                      Apex__ChannelResponse_Closure closure,
                      void *closure_data);
  void (*get_channels)(Apex__Endpoint_Service *service,
                       const Apex__Empty *input,
                       Apex__ChannelsResponse_Closure closure,
                       void *closure_data);
  void (*get_job)(Apex__Endpoint_Service *service,
                  const Apex__JobRequest *input,
                  Apex__JobResponse_Closure closure,
                  void *closure_data);
  void (*get_jobs)(Apex__Endpoint_Service *service,
                   const Apex__Empty *input,
                   Apex__JobsResponse_Closure closure,
                   void *closure_data);
  void (*get_job_status)(Apex__Endpoint_Service *service,
                         const Apex__JobRequest *input,
                         Apex__JobStatusResponse_Closure closure,
                         void *closure_data);
  void (*get_module)(Apex__Endpoint_Service *service,
                     const Apex__ModuleRequest *input,
                     Apex__ModuleResponse_Closure closure,
                     void *closure_data);
  void (*get_modules)(Apex__Endpoint_Service *service,
                      const Apex__Empty *input,
                      Apex__ModulesResponse_Closure closure,
                      void *closure_data);
  void (*try_module_connect)(Apex__Endpoint_Service *service,
                             const Apex__ModuleRequest *input,
                             Apex__JobResponse_Closure closure,
                             void *closure_data);
  void (*try_module_disconnect)(Apex__Endpoint_Service *service,
                                const Apex__ModuleRequest *input,
                                Apex__JobResponse_Closure closure,
                                void *closure_data);
  void (*try_module_load)(Apex__Endpoint_Service *service,
                          const Apex__ModuleRequest *input,
                          Apex__JobResponse_Closure closure,
                          void *closure_data);
  void (*try_module_unload)(Apex__Endpoint_Service *service,
                            const Apex__ModuleRequest *input,
                            Apex__JobResponse_Closure closure,
                            void *closure_data);
  void (*try_module_reload)(Apex__Endpoint_Service *service,
                            const Apex__ModuleRequest *input,
                            Apex__JobResponse_Closure closure,
                            void *closure_data);
  void (*try_module_enable)(Apex__Endpoint_Service *service,
                            const Apex__ModuleRequest *input,
                            Apex__JobResponse_Closure closure,
                            void *closure_data);
  void (*try_module_disable)(Apex__Endpoint_Service *service,
                             const Apex__ModuleRequest *input,
                             Apex__JobResponse_Closure closure,
                             void *closure_data);
  void (*get_module_configuration)(Apex__Endpoint_Service *service,
                                   const Apex__ModuleRequest *input,
                                   Apex__ConfigurationResponse_Closure closure,
                                   void *closure_data);
  void (*get_module_status)(Apex__Endpoint_Service *service,
                            const Apex__ModuleRequest *input,
                            Apex__StatusResponse_Closure closure,
                            void *closure_data);
  void (*get_module_settings)(Apex__Endpoint_Service *service,
                              const Apex__ModuleRequest *input,
                              Apex__SettingsResponse_Closure closure,
                              void *closure_data);
  void (*get_module_job)(Apex__Endpoint_Service *service,
                         const Apex__ModuleRequest *input,
                         Apex__JobResponse_Closure closure,
                         void *closure_data);
  void (*get_module_jobs)(Apex__Endpoint_Service *service,
                          const Apex__ModuleRequest *input,
                          Apex__JobsResponse_Closure closure,
                          void *closure_data);
  void (*get_module_active_job)(Apex__Endpoint_Service *service,
                                const Apex__ModuleRequest *input,
                                Apex__JobResponse_Closure closure,
                                void *closure_data);
  void (*module_cancel_job)(Apex__Endpoint_Service *service,
                            const Apex__ModuleJobRequest *input,
                            Apex__JobResponse_Closure closure,
                            void *closure_data);
  void (*module_submit_event)(Apex__Endpoint_Service *service,
                              const Apex__ModuleEventRequest *input,
                              Apex__JobResponse_Closure closure,
                              void *closure_data);
  void (*module_available_events)(Apex__Endpoint_Service *service,
                                  const Apex__ModuleRequest *input,
                                  Apex__EventsResponse_Closure closure,
                                  void *closure_data);
};
typedef void (*Apex__Endpoint_ServiceDestroy)(Apex__Endpoint_Service *);
void apex__endpoint__init (Apex__Endpoint_Service *service,
                           Apex__Endpoint_ServiceDestroy destroy);
#define APEX__ENDPOINT__BASE_INIT \
    { &apex__endpoint__descriptor, protobuf_c_service_invoke_internal, NULL }
#define APEX__ENDPOINT__INIT(function_prefix__) \
    { APEX__ENDPOINT__BASE_INIT,\
      function_prefix__ ## get_unit_configuration,\
      function_prefix__ ## get_configuration,\
      function_prefix__ ## get_status,\
      function_prefix__ ## get_settings,\
      function_prefix__ ## get_channel,\
      function_prefix__ ## get_channels,\
      function_prefix__ ## get_job,\
      function_prefix__ ## get_jobs,\
      function_prefix__ ## get_job_status,\
      function_prefix__ ## get_module,\
      function_prefix__ ## get_modules,\
      function_prefix__ ## try_module_connect,\
      function_prefix__ ## try_module_disconnect,\
      function_prefix__ ## try_module_load,\
      function_prefix__ ## try_module_unload,\
      function_prefix__ ## try_module_reload,\
      function_prefix__ ## try_module_enable,\
      function_prefix__ ## try_module_disable,\
      function_prefix__ ## get_module_configuration,\
      function_prefix__ ## get_module_status,\
      function_prefix__ ## get_module_settings,\
      function_prefix__ ## get_module_job,\
      function_prefix__ ## get_module_jobs,\
      function_prefix__ ## get_module_active_job,\
      function_prefix__ ## module_cancel_job,\
      function_prefix__ ## module_submit_event,\
      function_prefix__ ## module_available_events  }
void apex__endpoint__get_unit_configuration(ProtobufCService *service,
                                            const Apex__Empty *input,
                                            Apex__ConfigurationResponse_Closure closure,
                                            void *closure_data);
void apex__endpoint__get_configuration(ProtobufCService *service,
                                       const Apex__ConfigurationRequest *input,
                                       Apex__ConfigurationResponse_Closure closure,
                                       void *closure_data);
void apex__endpoint__get_status(ProtobufCService *service,
                                const Apex__StatusRequest *input,
                                Apex__StatusResponse_Closure closure,
                                void *closure_data);
void apex__endpoint__get_settings(ProtobufCService *service,
                                  const Apex__SettingsRequest *input,
                                  Apex__SettingsResponse_Closure closure,
                                  void *closure_data);
void apex__endpoint__get_channel(ProtobufCService *service,
                                 const Apex__ChannelRequest *input,
                                 Apex__ChannelResponse_Closure closure,
                                 void *closure_data);
void apex__endpoint__get_channels(ProtobufCService *service,
                                  const Apex__Empty *input,
                                  Apex__ChannelsResponse_Closure closure,
                                  void *closure_data);
void apex__endpoint__get_job(ProtobufCService *service,
                             const Apex__JobRequest *input,
                             Apex__JobResponse_Closure closure,
                             void *closure_data);
void apex__endpoint__get_jobs(ProtobufCService *service,
                              const Apex__Empty *input,
                              Apex__JobsResponse_Closure closure,
                              void *closure_data);
void apex__endpoint__get_job_status(ProtobufCService *service,
                                    const Apex__JobRequest *input,
                                    Apex__JobStatusResponse_Closure closure,
                                    void *closure_data);
void apex__endpoint__get_module(ProtobufCService *service,
                                const Apex__ModuleRequest *input,
                                Apex__ModuleResponse_Closure closure,
                                void *closure_data);
void apex__endpoint__get_modules(ProtobufCService *service,
                                 const Apex__Empty *input,
                                 Apex__ModulesResponse_Closure closure,
                                 void *closure_data);
void apex__endpoint__try_module_connect(ProtobufCService *service,
                                        const Apex__ModuleRequest *input,
                                        Apex__JobResponse_Closure closure,
                                        void *closure_data);
void apex__endpoint__try_module_disconnect(ProtobufCService *service,
                                           const Apex__ModuleRequest *input,
                                           Apex__JobResponse_Closure closure,
                                           void *closure_data);
void apex__endpoint__try_module_load(ProtobufCService *service,
                                     const Apex__ModuleRequest *input,
                                     Apex__JobResponse_Closure closure,
                                     void *closure_data);
void apex__endpoint__try_module_unload(ProtobufCService *service,
                                       const Apex__ModuleRequest *input,
                                       Apex__JobResponse_Closure closure,
                                       void *closure_data);
void apex__endpoint__try_module_reload(ProtobufCService *service,
                                       const Apex__ModuleRequest *input,
                                       Apex__JobResponse_Closure closure,
                                       void *closure_data);
void apex__endpoint__try_module_enable(ProtobufCService *service,
                                       const Apex__ModuleRequest *input,
                                       Apex__JobResponse_Closure closure,
                                       void *closure_data);
void apex__endpoint__try_module_disable(ProtobufCService *service,
                                        const Apex__ModuleRequest *input,
                                        Apex__JobResponse_Closure closure,
                                        void *closure_data);
void apex__endpoint__get_module_configuration(ProtobufCService *service,
                                              const Apex__ModuleRequest *input,
                                              Apex__ConfigurationResponse_Closure closure,
                                              void *closure_data);
void apex__endpoint__get_module_status(ProtobufCService *service,
                                       const Apex__ModuleRequest *input,
                                       Apex__StatusResponse_Closure closure,
                                       void *closure_data);
void apex__endpoint__get_module_settings(ProtobufCService *service,
                                         const Apex__ModuleRequest *input,
                                         Apex__SettingsResponse_Closure closure,
                                         void *closure_data);
void apex__endpoint__get_module_job(ProtobufCService *service,
                                    const Apex__ModuleRequest *input,
                                    Apex__JobResponse_Closure closure,
                                    void *closure_data);
void apex__endpoint__get_module_jobs(ProtobufCService *service,
                                     const Apex__ModuleRequest *input,
                                     Apex__JobsResponse_Closure closure,
                                     void *closure_data);
void apex__endpoint__get_module_active_job(ProtobufCService *service,
                                           const Apex__ModuleRequest *input,
                                           Apex__JobResponse_Closure closure,
                                           void *closure_data);
void apex__endpoint__module_cancel_job(ProtobufCService *service,
                                       const Apex__ModuleJobRequest *input,
                                       Apex__JobResponse_Closure closure,
                                       void *closure_data);
void apex__endpoint__module_submit_event(ProtobufCService *service,
                                         const Apex__ModuleEventRequest *input,
                                         Apex__JobResponse_Closure closure,
                                         void *closure_data);
void apex__endpoint__module_available_events(ProtobufCService *service,
                                             const Apex__ModuleRequest *input,
                                             Apex__EventsResponse_Closure closure,
                                             void *closure_data);

/* --- descriptors --- */

extern const ProtobufCMessageDescriptor apex__empty__descriptor;
extern const ProtobufCMessageDescriptor apex__property__descriptor;
extern const ProtobufCMessageDescriptor apex__object__descriptor;
extern const ProtobufCMessageDescriptor apex__configuration__descriptor;
extern const ProtobufCEnumDescriptor    apex__configuration__namespace__descriptor;
extern const ProtobufCMessageDescriptor apex__job__descriptor;
extern const ProtobufCEnumDescriptor    apex__job__status__descriptor;
extern const ProtobufCMessageDescriptor apex__settings__descriptor;
extern const ProtobufCMessageDescriptor apex__settings__properties_entry__descriptor;
extern const ProtobufCMessageDescriptor apex__channel__descriptor;
extern const ProtobufCEnumDescriptor    apex__channel__type__descriptor;
extern const ProtobufCMessageDescriptor apex__status__descriptor;
extern const ProtobufCMessageDescriptor apex__status__details_entry__descriptor;
extern const ProtobufCMessageDescriptor apex__state__descriptor;
extern const ProtobufCMessageDescriptor apex__event__descriptor;
extern const ProtobufCMessageDescriptor apex__service__descriptor;
extern const ProtobufCEnumDescriptor    apex__service__type__descriptor;
extern const ProtobufCMessageDescriptor apex__module__descriptor;
extern const ProtobufCMessageDescriptor apex__system__descriptor;
extern const ProtobufCMessageDescriptor apex__system__services_entry__descriptor;
extern const ProtobufCMessageDescriptor apex__system__modules_entry__descriptor;
extern const ProtobufCMessageDescriptor apex__configuration_request__descriptor;
extern const ProtobufCMessageDescriptor apex__configuration_response__descriptor;
extern const ProtobufCMessageDescriptor apex__configurations_response__descriptor;
extern const ProtobufCMessageDescriptor apex__settings_request__descriptor;
extern const ProtobufCMessageDescriptor apex__settings_response__descriptor;
extern const ProtobufCMessageDescriptor apex__settings_response__settings_entry__descriptor;
extern const ProtobufCMessageDescriptor apex__status_request__descriptor;
extern const ProtobufCMessageDescriptor apex__status_response__descriptor;
extern const ProtobufCMessageDescriptor apex__channel_request__descriptor;
extern const ProtobufCMessageDescriptor apex__channel_response__descriptor;
extern const ProtobufCMessageDescriptor apex__channels_response__descriptor;
extern const ProtobufCMessageDescriptor apex__job_request__descriptor;
extern const ProtobufCEnumDescriptor    apex__job_request__type__descriptor;
extern const ProtobufCMessageDescriptor apex__job_response__descriptor;
extern const ProtobufCMessageDescriptor apex__jobs_response__descriptor;
extern const ProtobufCMessageDescriptor apex__job_status_response__descriptor;
extern const ProtobufCMessageDescriptor apex__event_request__descriptor;
extern const ProtobufCMessageDescriptor apex__events_response__descriptor;
extern const ProtobufCMessageDescriptor apex__module_request__descriptor;
extern const ProtobufCMessageDescriptor apex__module_response__descriptor;
extern const ProtobufCMessageDescriptor apex__modules_response__descriptor;
extern const ProtobufCMessageDescriptor apex__module_job_request__descriptor;
extern const ProtobufCMessageDescriptor apex__module_event_request__descriptor;
extern const ProtobufCServiceDescriptor apex__endpoint__descriptor;

PROTOBUF_C__END_DECLS


#endif  /* PROTOBUF_C_apex_2fcore_2eproto__INCLUDED */
